import numpy as np
import matplotlib.pyplot as plt

plt.close('all')

def maxi(liste_num):
    """Recherche du maximum d'une liste numérique"""
    m=liste_num[0]
    for k in range(len(liste_num)):
        if liste_num[k]>m:
            m=liste_num[k]
            indice=k
    return m,indice

def planck(T,L):
    h=6.62e-34
    c=3e8
    k=1.38e-23
    return 2*np.pi*h*c**2/(L**5)*1/(np.exp(h*c/(k*T*L))-1)


x=np.linspace(1e-10,1e-5,1000)

for T in range(500, 5000, 500):
    Lm=x[maxi(planck(T,x))[1]]
    print("Pour T=",T,"K la longueur d'onde du max d'émission vaut ",Lm,"m")
    print("T",chr(955),"m=",T*Lm,sep="")
    y=planck(T,x)
    plt.figure(1)
    plt.plot(x,y)
    plt.grid()
    plt.xlabel('$\lambda$ en m', size='xx-large')
    plt.ylabel('$f_T(\lambda)$',size='xx-large')
    plt.title('$f_T(\lambda)$',size='xx-large')
    plt.savefig('graphe.pdf')
plt.show()

Temp=[]
invlambdam=[]
for T in range(500, 5000, 200):
	Lm=x[maxi(planck(T,x))[1]]
	Temp.append(T)
	invlambdam.append(1/Lm)

a,b= np.polyfit(Temp,invlambdam,1)

print('pente=', a,"K.m")
print('o.o=', b,"m")
plt.figure(2)
plt.plot(Temp,invlambdam,'o')
plt.grid()
plt.xlabel(r'$T$ en K')
plt.ylabel(r'$1/\lambda_m$')
plt.title(r'$1/\lambda_m=f(T)$')
plt.show()

